{
    "$graph": [
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/account"
                },
                {
                    "type": "string",
                    "id": "#main/data_path"
                },
                {
                    "type": "int",
                    "id": "#main/frequency"
                },
                {
                    "type": "string",
                    "id": "#main/hrz_atm_map_path"
                },
                {
                    "type": "string",
                    "id": "#main/metadata_path"
                },
                {
                    "type": "int",
                    "id": "#main/num_workers"
                },
                {
                    "type": "string",
                    "id": "#main/partition"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/plev_cmor_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/plev_var_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/std_cmor_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/std_var_list"
                },
                {
                    "type": "string",
                    "id": "#main/tables_path"
                },
                {
                    "type": "string",
                    "id": "#main/timeout"
                },
                {
                    "type": "string",
                    "id": "#main/vrt_map_path"
                }
            ],
            "steps": [
                {
                    "run": "#discover_atm_files.cwl",
                    "in": [
                        {
                            "source": "#main/step_segments/segments_end",
                            "id": "#main/step_discover_atm_files/end"
                        },
                        {
                            "source": "#main/data_path",
                            "id": "#main/step_discover_atm_files/input"
                        },
                        {
                            "source": "#main/step_segments/segments_start",
                            "id": "#main/step_discover_atm_files/start"
                        }
                    ],
                    "scatter": [
                        "#main/step_discover_atm_files/start",
                        "#main/step_discover_atm_files/end"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#main/step_discover_atm_files/atm_files"
                    ],
                    "id": "#main/step_discover_atm_files"
                },
                {
                    "run": "#find_casename.cwl",
                    "in": [
                        {
                            "source": "#main/data_path",
                            "id": "#main/step_find_casename/atm_data_path"
                        }
                    ],
                    "out": [
                        "#main/step_find_casename/casename"
                    ],
                    "id": "#main/step_find_casename"
                },
                {
                    "run": "#find_start_end.cwl",
                    "in": [
                        {
                            "source": "#main/data_path",
                            "id": "#main/step_find_start_end/data_path"
                        }
                    ],
                    "out": [
                        "#main/step_find_start_end/start_year",
                        "#main/step_find_start_end/end_year"
                    ],
                    "id": "#main/step_find_start_end"
                },
                {
                    "run": "#cmor.cwl",
                    "scatter": [
                        "#main/step_plev_cmor/raw_file_list"
                    ],
                    "in": [
                        {
                            "source": "#main/account",
                            "id": "#main/step_plev_cmor/account"
                        },
                        {
                            "source": "#main/metadata_path",
                            "id": "#main/step_plev_cmor/metadata_path"
                        },
                        {
                            "source": "#main/num_workers",
                            "id": "#main/step_plev_cmor/num_workers"
                        },
                        {
                            "source": "#main/partition",
                            "id": "#main/step_plev_cmor/partition"
                        },
                        {
                            "source": "#main/step_plev_hrz_remap/time_series_files",
                            "id": "#main/step_plev_cmor/raw_file_list"
                        },
                        {
                            "source": "#main/tables_path",
                            "id": "#main/step_plev_cmor/tables_path"
                        },
                        {
                            "source": "#main/timeout",
                            "id": "#main/step_plev_cmor/timeout"
                        },
                        {
                            "source": "#main/plev_cmor_list",
                            "id": "#main/step_plev_cmor/var_list"
                        }
                    ],
                    "out": [
                        "#main/step_plev_cmor/cmip6_dir",
                        "#main/step_plev_cmor/cmor_logs"
                    ],
                    "id": "#main/step_plev_cmor"
                },
                {
                    "run": "#hrzremap_posin.cwl",
                    "scatter": [
                        "#main/step_plev_hrz_remap/input_files",
                        "#main/step_plev_hrz_remap/start_year",
                        "#main/step_plev_hrz_remap/end_year"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/account",
                            "id": "#main/step_plev_hrz_remap/account"
                        },
                        {
                            "source": "#main/step_find_casename/casename",
                            "id": "#main/step_plev_hrz_remap/casename"
                        },
                        {
                            "source": "#main/step_segments/segments_end",
                            "id": "#main/step_plev_hrz_remap/end_year"
                        },
                        {
                            "source": "#main/step_vrt_remap/vrt_remapped_file",
                            "id": "#main/step_plev_hrz_remap/input_files"
                        },
                        {
                            "source": "#main/hrz_atm_map_path",
                            "id": "#main/step_plev_hrz_remap/mapfile"
                        },
                        {
                            "source": "#main/partition",
                            "id": "#main/step_plev_hrz_remap/partition"
                        },
                        {
                            "source": "#main/step_segments/segments_start",
                            "id": "#main/step_plev_hrz_remap/start_year"
                        },
                        {
                            "source": "#main/timeout",
                            "id": "#main/step_plev_hrz_remap/timeout"
                        },
                        {
                            "source": "#main/plev_var_list",
                            "id": "#main/step_plev_hrz_remap/variables"
                        },
                        {
                            "source": "#main/frequency",
                            "id": "#main/step_plev_hrz_remap/year_per_file"
                        }
                    ],
                    "out": [
                        "#main/step_plev_hrz_remap/time_series_files"
                    ],
                    "id": "#main/step_plev_hrz_remap"
                },
                {
                    "run": "#file_to_string_list.cwl",
                    "scatter": "#main/step_pull_paths/a_File",
                    "in": [
                        {
                            "source": "#main/step_discover_atm_files/atm_files",
                            "id": "#main/step_pull_paths/a_File"
                        }
                    ],
                    "out": [
                        "#main/step_pull_paths/list_of_strings"
                    ],
                    "id": "#main/step_pull_paths"
                },
                {
                    "run": "#generate_segments.cwl",
                    "in": [
                        {
                            "source": "#main/step_find_start_end/end_year",
                            "id": "#main/step_segments/end"
                        },
                        {
                            "source": "#main/frequency",
                            "id": "#main/step_segments/frequency"
                        },
                        {
                            "source": "#main/step_find_start_end/start_year",
                            "id": "#main/step_segments/start"
                        }
                    ],
                    "out": [
                        "#main/step_segments/segments_start",
                        "#main/step_segments/segments_end"
                    ],
                    "id": "#main/step_segments"
                },
                {
                    "run": "#cmor.cwl",
                    "scatter": [
                        "#main/step_std_cmor/raw_file_list"
                    ],
                    "in": [
                        {
                            "source": "#main/account",
                            "id": "#main/step_std_cmor/account"
                        },
                        {
                            "source": "#main/metadata_path",
                            "id": "#main/step_std_cmor/metadata_path"
                        },
                        {
                            "source": "#main/num_workers",
                            "id": "#main/step_std_cmor/num_workers"
                        },
                        {
                            "source": "#main/partition",
                            "id": "#main/step_std_cmor/partition"
                        },
                        {
                            "source": "#main/step_std_hrz_remap/time_series_files",
                            "id": "#main/step_std_cmor/raw_file_list"
                        },
                        {
                            "source": "#main/tables_path",
                            "id": "#main/step_std_cmor/tables_path"
                        },
                        {
                            "source": "#main/timeout",
                            "id": "#main/step_std_cmor/timeout"
                        },
                        {
                            "source": "#main/std_cmor_list",
                            "id": "#main/step_std_cmor/var_list"
                        }
                    ],
                    "out": [
                        "#main/step_std_cmor/cmip6_dir",
                        "#main/step_std_cmor/cmor_logs"
                    ],
                    "id": "#main/step_std_cmor"
                },
                {
                    "run": "#hrzremap_posin_paths.cwl",
                    "scatter": [
                        "#main/step_std_hrz_remap/input_files",
                        "#main/step_std_hrz_remap/start_year",
                        "#main/step_std_hrz_remap/end_year"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/account",
                            "id": "#main/step_std_hrz_remap/account"
                        },
                        {
                            "source": "#main/step_find_casename/casename",
                            "id": "#main/step_std_hrz_remap/casename"
                        },
                        {
                            "source": "#main/step_segments/segments_end",
                            "id": "#main/step_std_hrz_remap/end_year"
                        },
                        {
                            "source": "#main/step_pull_paths/list_of_strings",
                            "id": "#main/step_std_hrz_remap/input_files"
                        },
                        {
                            "source": "#main/hrz_atm_map_path",
                            "id": "#main/step_std_hrz_remap/mapfile"
                        },
                        {
                            "source": "#main/partition",
                            "id": "#main/step_std_hrz_remap/partition"
                        },
                        {
                            "source": "#main/step_segments/segments_start",
                            "id": "#main/step_std_hrz_remap/start_year"
                        },
                        {
                            "source": "#main/timeout",
                            "id": "#main/step_std_hrz_remap/timeout"
                        },
                        {
                            "source": "#main/std_var_list",
                            "id": "#main/step_std_hrz_remap/variables"
                        },
                        {
                            "source": "#main/frequency",
                            "id": "#main/step_std_hrz_remap/year_per_file"
                        }
                    ],
                    "out": [
                        "#main/step_std_hrz_remap/time_series_files"
                    ],
                    "id": "#main/step_std_hrz_remap"
                },
                {
                    "run": "#vrtremap.cwl",
                    "scatter": [
                        "#main/step_vrt_remap/infiles"
                    ],
                    "in": [
                        {
                            "source": "#main/account",
                            "id": "#main/step_vrt_remap/account"
                        },
                        {
                            "source": "#main/step_find_casename/casename",
                            "id": "#main/step_vrt_remap/casename"
                        },
                        {
                            "source": "#main/step_pull_paths/list_of_strings",
                            "id": "#main/step_vrt_remap/infiles"
                        },
                        {
                            "source": "#main/num_workers",
                            "id": "#main/step_vrt_remap/num_workers"
                        },
                        {
                            "source": "#main/partition",
                            "id": "#main/step_vrt_remap/partition"
                        },
                        {
                            "source": "#main/timeout",
                            "id": "#main/step_vrt_remap/timeout"
                        },
                        {
                            "source": "#main/vrt_map_path",
                            "id": "#main/step_vrt_remap/vrtmap"
                        }
                    ],
                    "out": [
                        "#main/step_vrt_remap/vrt_remapped_file"
                    ],
                    "id": "#main/step_vrt_remap"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "outputSource": [
                        "#main/step_std_cmor/cmip6_dir",
                        "#main/step_plev_cmor/cmip6_dir"
                    ],
                    "linkMerge": "merge_flattened",
                    "id": "#main/cmorized"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "outputSource": [
                        "#main/step_std_cmor/cmor_logs",
                        "#main/step_plev_cmor/cmor_logs"
                    ],
                    "linkMerge": "merge_flattened",
                    "id": "#main/logs"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "srun"
            ],
            "requirements": [
                {
                    "listing": [
                        "$(inputs.raw_file_list)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#cmor.cwl/account"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--user-metadata"
                    },
                    "id": "#cmor.cwl/metadata_path"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--num-proc"
                    },
                    "id": "#cmor.cwl/num_workers"
                },
                {
                    "type": "string",
                    "id": "#cmor.cwl/partition"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#cmor.cwl/raw_file_list"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--tables-path"
                    },
                    "id": "#cmor.cwl/tables_path"
                },
                {
                    "type": "string",
                    "id": "#cmor.cwl/timeout"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#cmor.cwl/var_list"
                }
            ],
            "arguments": [
                "-A",
                "$(inputs.account)",
                "--partition",
                "$(inputs.partition)",
                "-t",
                "$(inputs.timeout)",
                "e3sm_to_cmip",
                {
                    "prefix": "--output-path",
                    "valueFrom": "$(runtime.outdir)"
                },
                {
                    "prefix": "--var-list",
                    "valueFrom": "$(inputs.var_list.join(\", \"))"
                },
                {
                    "prefix": "--input-path",
                    "valueFrom": "."
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "CMIP6"
                    },
                    "id": "#cmor.cwl/cmip6_dir"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "cmor_logs"
                    },
                    "id": "#cmor.cwl/cmor_logs"
                }
            ],
            "id": "#cmor.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "discover_atm_files.py"
            ],
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "discover_atm_files.py",
                            "entry": "import os\nimport sys\nimport re\nimport argparse\n\ndef get_year(filename):\n\n    pattern = r'\\d{4}-\\d{2}'\n    idx = re.search(pattern, filename)\n    if idx is None:\n        print(filename)\n    return int( filename[idx.start(): idx.end()-3] )\n\ndef main():\n    parser = argparse.ArgumentParser()\n    parser.add_argument(\n        '-i', '--input', help=\"root input path\")\n    parser.add_argument(\n        '-s', '--start-year', help=\"start year\", type=int)\n    parser.add_argument(\n        '-e', '--end-year', help=\"end year\", type=int)\n    _args = parser.parse_args(sys.argv[1:])\n    \n    inpath = _args.input\n    if not os.path.exists(inpath):\n        print(\"ERROR: directory not found {}\".format(inpath), file=sys.stderr)\n        return 1\n\n    start = _args.start_year\n    end = _args.end_year\n\n    atm_pattern = 'cam.h0'\n    atm_files = list()\n\n    for root, _, files in os.walk(inpath):\n        if files:\n            for f in files:\n                if atm_pattern in f:\n                    year = get_year(f)\n                    if year >= start and year <= end:\n                        atm_files.append(os.path.join(root, f))\n\n    for f in sorted(atm_files):\n        print(f)\n\n    return 0\n    \nif __name__ == \"__main__\":\n    sys.exit(main())\n"
                        }
                    ]
                }
            ],
            "stdout": "atm_files.txt",
            "inputs": [
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--end"
                    },
                    "id": "#discover_atm_files.cwl/end"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input"
                    },
                    "id": "#discover_atm_files.cwl/input"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--start"
                    },
                    "id": "#discover_atm_files.cwl/start"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#discover_atm_files.cwl/atm_files",
                    "outputBinding": {
                        "glob": "atm_files.txt"
                    }
                }
            ],
            "id": "#discover_atm_files.cwl"
        },
        {
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "File",
                    "id": "#file_to_string_list.cwl/a_File"
                }
            ],
            "baseCommand": "python",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "import json\nlist_of_strings = []\nwith open(\"$(inputs.a_File.path)\", \"r\") as infile:\n  list_of_strings = infile.read().split()\nwith open(\"cwl.output.json\", \"w\") as output:\n  json.dump({\"list_of_strings\": list_of_strings}, output)\n"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#file_to_string_list.cwl/list_of_strings"
                }
            ],
            "id": "#file_to_string_list.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "find_casename.py"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "find_casename.py",
                            "entry": "import os\nimport sys\nimport argparse\nimport json\ndef main():\n    p = argparse.ArgumentParser()\n    p.add_argument('--atm-data-path')\n    args = p.parse_args()\n    filename = os.listdir(args.atm_data_path)[0]\n    i = filename.index('.cam.h0')\n    if i == -1:\n        return -1\n    with open(\"cwl.output.json\", \"w\") as output:\n        json.dump({\"casename\": filename[:i]}, output)\nif __name__ == \"__main__\":\n    sys.exit(main())\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--atm-data-path"
                    },
                    "id": "#find_casename.cwl/atm_data_path"
                }
            ],
            "outputs": [
                {
                    "type": "string",
                    "id": "#find_casename.cwl/casename"
                }
            ],
            "id": "#find_casename.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "get_start_end.py"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "get_start_end.py",
                            "entry": "import argparse\nimport sys\nimport os\ndef get_year(filepath):\n    # Works for files matching the pattern: \"somelongcasename.cam.h0.1850-12.nc\"\n    return filepath[-10:-6]\ndef main():\n    parser = argparse.ArgumentParser()\n    parser.add_argument('--data-path')\n\n    files = sorted([get_year(x) for x in os.listdir(parser.parse_args().data_path)])\n    with open('start.txt', 'w') as start_out, open('end.txt', 'w') as end_out:\n      start_out.write(files[0])\n      end_out.write(files[-1])\n      print(\"Data files found from years {} to {} \".format(files[0], files[-1]))\n    return 0\nif __name__ == \"__main__\":\n    sys.exit(main())\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--data-path"
                    },
                    "id": "#find_start_end.cwl/data_path"
                }
            ],
            "outputs": [
                {
                    "type": "int",
                    "outputBinding": {
                        "glob": "end.txt",
                        "loadContents": true,
                        "outputEval": "$( parseInt(self[0].contents) )"
                    },
                    "id": "#find_start_end.cwl/end_year"
                },
                {
                    "type": "int",
                    "outputBinding": {
                        "glob": "start.txt",
                        "loadContents": true,
                        "outputEval": "$( parseInt(self[0].contents) )\n"
                    },
                    "id": "#find_start_end.cwl/start_year"
                }
            ],
            "id": "#find_start_end.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "generate_segments.py"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "generate_segments.py",
                            "entry": "import sys\nimport argparse\ndef main():\n    parser = argparse.ArgumentParser()\n    parser.add_argument('--start')\n    parser.add_argument('--end')\n    parser.add_argument('--frequency')\n    _args = parser.parse_args(sys.argv[1:])\n\n    start = int(_args.start)\n    end = int(_args.end)\n    freq = int(_args.frequency)\n\n    seg_start = start\n    seg_end = start + freq - 1\n\n    start_outname = 'segments_start_{}_{}.txt'.format(start, end)\n    end_outname = 'segments_end_{}_{}.txt'.format(start, end)\n\n    with open(start_outname, 'w') as segstart:\n        with open(end_outname, 'w') as segend:\n\n            while seg_end < end:\n                segstart.write(\"{}\\n\".format(seg_start))\n                segend.write(\"{}\\n\".format(seg_end))\n                seg_start += freq\n                seg_end += freq\n            if seg_end == end:\n                segstart.write(\"{}\".format(seg_start))\n                segend.write(\"{}\".format(seg_end))\n            if seg_end > end:\n                segstart.write(\"{}\\n\".format(seg_end - freq + 1))\n                segend.write(\"{}\\n\".format(end))\n    return 0\nif __name__ == \"__main__\":\n    sys.exit(main())\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--end"
                    },
                    "id": "#generate_segments.cwl/end"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--frequency"
                    },
                    "id": "#generate_segments.cwl/frequency"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--start"
                    },
                    "id": "#generate_segments.cwl/start"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "glob": "segments_end*",
                        "loadContents": true,
                        "outputEval": "$( \n  self[0].contents.split('\\n').map(function(x){\n    return parseInt(x);\n  }).filter(function(x){return x})\n)"
                    },
                    "id": "#generate_segments.cwl/segments_end"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "glob": "segments_start*",
                        "loadContents": true,
                        "outputEval": "$( \n  self[0].contents.split('\\n').map(function(x){\n    return parseInt(x);\n  }).filter(function(x){return x})\n)\n"
                    },
                    "id": "#generate_segments.cwl/segments_start"
                }
            ],
            "id": "#generate_segments.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "srun"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#hrzremap_posin.cwl/account"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin.cwl/casename"
                },
                {
                    "type": "int",
                    "id": "#hrzremap_posin.cwl/end_year"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#hrzremap_posin.cwl/input_files"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin.cwl/mapfile"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin.cwl/partition"
                },
                {
                    "type": "int",
                    "id": "#hrzremap_posin.cwl/start_year"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin.cwl/timeout"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#hrzremap_posin.cwl/variables"
                },
                {
                    "type": "int",
                    "id": "#hrzremap_posin.cwl/year_per_file"
                }
            ],
            "arguments": [
                "-A",
                "$(inputs.account)",
                "--partition",
                "$(inputs.partition)",
                "-t",
                "$(inputs.timeout)",
                "ncclimo",
                "-7",
                "--dfl_lvl=1",
                "--no_cll_msr",
                "--no_stdin",
                "-a",
                "sdd",
                "-O",
                "$(runtime.outdir)",
                "-o",
                "./native",
                "-v",
                "$(inputs.variables.join(\" \"))",
                "-s",
                "$(inputs.start_year)",
                "-e",
                "$(inputs.end_year)",
                "$(\"--ypf=\" + inputs.year_per_file)",
                "$(\"--map=\" + inputs.mapfile)",
                "-c",
                "$(inputs.casename)",
                "$(inputs.input_files)"
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": [
                            "*.nc"
                        ]
                    },
                    "id": "#hrzremap_posin.cwl/time_series_files"
                }
            ],
            "id": "#hrzremap_posin.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "srun"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#hrzremap_posin_paths.cwl/account"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin_paths.cwl/casename"
                },
                {
                    "type": "int",
                    "id": "#hrzremap_posin_paths.cwl/end_year"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#hrzremap_posin_paths.cwl/input_files"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin_paths.cwl/mapfile"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin_paths.cwl/partition"
                },
                {
                    "type": "int",
                    "id": "#hrzremap_posin_paths.cwl/start_year"
                },
                {
                    "type": "string",
                    "id": "#hrzremap_posin_paths.cwl/timeout"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#hrzremap_posin_paths.cwl/variables"
                },
                {
                    "type": "int",
                    "id": "#hrzremap_posin_paths.cwl/year_per_file"
                }
            ],
            "arguments": [
                "-A",
                "$(inputs.account)",
                "--partition",
                "$(inputs.partition)",
                "-t",
                "$(inputs.timeout)",
                "ncclimo",
                "-7",
                "--dfl_lvl=1",
                "--no_cll_msr",
                "--no_stdin",
                "-a",
                "sdd",
                "-O",
                "$(runtime.outdir)",
                "-o",
                "./native",
                "-v",
                "$(inputs.variables.join(\" \"))",
                "-s",
                "$(inputs.start_year)",
                "-e",
                "$(inputs.end_year)",
                "$(\"--ypf=\" + inputs.year_per_file)",
                "$(\"--map=\" + inputs.mapfile)",
                "-c",
                "$(inputs.casename)",
                "$(inputs.input_files)"
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": [
                            "*.nc"
                        ]
                    },
                    "id": "#hrzremap_posin_paths.cwl/time_series_files"
                }
            ],
            "id": "#hrzremap_posin_paths.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "srun"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "vrtremap.py",
                            "entry": "import sys\nimport os\nimport argparse\n\nfrom multiprocessing import Pool\nfrom subprocess import Popen, PIPE\n\ndef vrt_remap(inpath, outpath, vrtfl):\n    _, head = os.path.split(inpath)\n    output_path = os.path.join(outpath, head)\n    print(\"Running vertical interpolation for: {}\".format(inpath))\n    cmd = ['ncks', '--rgr', 'xtr_mth=mss_val', '--vrt_fl={}'.format(vrtfl), inpath, output_path]\n    out, err = Popen(cmd, stderr=PIPE, stdout=PIPE).communicate()\n    if err:\n        print(err)\n    return out\n\ndef run_ncks():\n    parser = argparse.ArgumentParser()\n    parser.add_argument('--vrt_fl')\n    parser.add_argument('--output')\n    parser.add_argument('--num_workers', type=int)\n    parser.add_argument('--infiles', nargs=\"*\")\n    _args = parser.parse_args(sys.argv[1:])\n\n    pool = Pool(_args.num_workers)\n    res = list()\n\n    for inpath in _args.infiles:\n        if not os.path.exists(inpath):\n            print(\"Error: {} does not exist\".format(inpath))\n            return 1\n        else:\n          res.append(\n              pool.apply_async(\n                  vrt_remap,\n                  args=(inpath.strip(), _args.output, _args.vrt_fl)))\n\n    for r in res:\n        r.get(999999)\n    return 0\n\nif __name__ == \"__main__\":\n    sys.exit(run_ncks())\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#vrtremap.cwl/account"
                },
                {
                    "type": "string",
                    "id": "#vrtremap.cwl/casename"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#vrtremap.cwl/infiles"
                },
                {
                    "type": "int",
                    "id": "#vrtremap.cwl/num_workers"
                },
                {
                    "type": "string",
                    "id": "#vrtremap.cwl/partition"
                },
                {
                    "type": "string",
                    "id": "#vrtremap.cwl/timeout"
                },
                {
                    "type": "string",
                    "id": "#vrtremap.cwl/vrtmap"
                }
            ],
            "arguments": [
                "-A",
                "$(inputs.account)",
                "--partition",
                "$(inputs.partition)",
                "-t",
                "$(inputs.timeout)",
                "python",
                "vrtremap.py",
                "--output",
                "$(runtime.outdir)",
                "--vrt_fl",
                "$(inputs.vrtmap)",
                "--num_workers",
                "$(inputs.num_workers)",
                "--infiles",
                "$(inputs.infiles)"
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.casename).cam.h0.[0-9][0-9][0-9][0-9]-[0-9][0-9].nc"
                    },
                    "id": "#vrtremap.cwl/vrt_remapped_file"
                }
            ],
            "id": "#vrtremap.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
